"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.combineChunks = void 0;
var combineChunks = function (_a) {
    var chunks = _a.chunks;
    return chunks
        .sort(function (first, second) { return first.start - second.start; })
        .reduce(function (tempChunks, nextItem) {
        if (tempChunks.length === 0) {
            return [nextItem];
        }
        else {
            var prevItem = tempChunks.pop();
            if (prevItem && nextItem.start <= prevItem.end) {
                var endIndex = Math.max(prevItem.end, nextItem.end);
                tempChunks.push({
                    isHighlight: false,
                    start: prevItem.start,
                    end: endIndex,
                });
            }
            else if (prevItem && nextItem) {
                tempChunks.push(prevItem, nextItem);
            }
            return tempChunks;
        }
    }, []);
};
exports.combineChunks = combineChunks;
