"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findChunks = void 0;
var regex_1 = require("./utils/regex");
var string_1 = require("./utils/string");
var findChunks = function (_a) {
    var autoEscape = _a.autoEscape, caseSensitive = _a.caseSensitive, _b = _a.sanitize, sanitize = _b === void 0 ? string_1.defaultSanitize : _b, searchWords = _a.searchWords, textToHighlight = _a.textToHighlight;
    textToHighlight = sanitize(textToHighlight);
    /* Remove duplicate item
       Remove empty string */
    return searchWords
        .filter(function (item, index) { return searchWords.indexOf(item) === index; })
        .filter(function (searchWord) { return searchWord; })
        .reduce(function (chunks, searchWord) {
        searchWord = sanitize(searchWord);
        if (autoEscape) {
            searchWord = (0, regex_1.escapeRegExpFn)(searchWord);
        }
        var flag = caseSensitive ? 'g' : 'gi';
        var regex = new RegExp(searchWord, flag);
        var match;
        // tslint:disable-next-line
        while ((match = regex.exec(textToHighlight))) {
            var start = match.index;
            var end = regex.lastIndex;
            if (end > start) {
                chunks.push({ start: start, end: end, isHighlight: false });
            }
            if (match.index === regex.lastIndex) {
                regex.lastIndex++;
            }
        }
        return chunks;
    }, []);
};
exports.findChunks = findChunks;
